//+------------------------------------------------------------------+
//|                                                          RVI.mq4 |
//|                                                                  |
//------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"
//------------------------------------------------------------------

#property indicator_separate_window
#property indicator_buffers 9
#property indicator_color1  LimeGreen
#property indicator_color2  Orange
#property indicator_color3  Orange
#property indicator_color4  Red
#property indicator_color5  DodgerBlue
#property indicator_color6  DodgerBlue
#property indicator_color7  PaleVioletRed
#property indicator_color8  PaleVioletRed
#property indicator_color9  DimGray
#property indicator_width1  2
#property indicator_width2  2
#property indicator_width3  2
#property indicator_style4  STYLE_DOT
#property indicator_style6  STYLE_DOT
#property indicator_style7  STYLE_DOT
#property indicator_style9  STYLE_DASH

//
//
//
//
//

#import "dynamicZone.dll"
   double dzBuyP(double& sourceArray[],double probabiltyValue, int lookBack, int bars, int i, double precision);
   double dzSellP(double& sourceArray[],double probabiltyValue, int lookBack, int bars, int i, double precision);
#import

//
//
//
//
//

extern int    RVIPeriod               = 10;
extern int    StoPeriod               = 32;
extern int    StoSlowing              = 9;
extern int    DzLookBackBars          = 70;
extern double DzStartBuyProbability1  = 0.10;
extern double DzStartSellProbability1 = 0.10;
extern double DzStartBuyProbability2  = 0.25;
extern double DzStartSellProbability2 = 0.25;
extern bool   alertsOn                = true;
extern bool   alertsOnSlope           = true;
extern bool   alertsOnSignalCross     = true;
extern bool   alertsOnCurrent         = false;
extern bool   alertsMessage           = true;
extern bool   alertsSound             = true;
extern bool   alertsNotify            = false;
extern bool   alertsEmail             = false;
extern string soundFile               = "alert2.wav";
extern bool   ShowArrows              = true;
extern bool   arrowsOnSlope           = true;
extern bool   arrowsOnSignalCross     = true;
extern string arrowsIdentifier        = "dz stochrvi arrows1";
extern double arrowsUpperGap          = 0.5;
extern double arrowsLowerGap          = 0.5;
extern color  arrowsUpColor           = LimeGreen;
extern color  arrowsDnColor           = Red;
extern int    arrowsUpCode            = 241;
extern int    arrowsDnCode            = 242;


//
//
//
//
//

double stochRvi[];
double buffer3[];
double buffer4[];
double stochRviSignal[];
double bl1[];
double bl2[];
double sl1[];
double sl2[];
double zl1[];
double rvi[];
double buffer1[];
double buffer2[];
double trend[];
double slope[];

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int init()
{
   IndicatorBuffers(14);
      SetIndexBuffer(0, stochRvi);
      SetIndexBuffer(1, buffer3);
      SetIndexBuffer(2, buffer4);
      SetIndexBuffer(3, stochRviSignal);
      SetIndexBuffer(4, bl1);
      SetIndexBuffer(5, bl2);
      SetIndexBuffer(6, sl2);
      SetIndexBuffer(7, sl1);
      SetIndexBuffer(8, zl1);
      SetIndexBuffer(9, rvi);
      SetIndexBuffer(10,buffer1);
      SetIndexBuffer(11,buffer2);
      SetIndexBuffer(12,trend);
      SetIndexBuffer(13,slope);
   IndicatorShortName("Dynamic zone Stochastic of Rvi");
   return(0);
}
int deinit()
{ 
   deleteArrows();  
return(0);
}

//+------------------------------------------------------------------+
//|                                                                  |
//+------------------------------------------------------------------+
//
//
//
//
//

int start()
{
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
          
   //
   //
   //
   //
   //
   
   if (slope[limit]==-1) CleanPoint(limit,buffer3,buffer4);
   for(int i=limit; i>=0; i--)
   {
      buffer1[i] = ((Close[i]-Open[i])+2*(Close[i+1]-Open[i+1])+2*(Close[i+2]-Open[i+2])+(Close[i+3]-Open[i+3]))/6;
      buffer2[i] = ((High[i]-Low[i])  +2*(High[i+1]-Low[i+1])  +2*(High[i+2]-Low[i+2])  +(High[i+3]-Low[i+3])  )/6;
      
      //
      //
      //
      //
      //
      
      double num   = 0.0; 
      double denom = 0.0;
         for(int k=0; k<RVIPeriod; k++)
         {
            num   += buffer1[i+k];
            denom += buffer2[i+k];
         }
         if(denom!=0.0)
               rvi[i] = num/denom;
         else  rvi[i] = 0.0;
         
         //
         //
         //
         //
         //
         
         stochRvi[i]       = iStoch(rvi[i],rvi[i],rvi[i],StoPeriod,StoSlowing,i,0);
         stochRviSignal[i] = (stochRvi[i]+2*stochRvi[i+1]+2*stochRvi[i+2]+stochRvi[i+3])/6; 
         if (DzStartBuyProbability1  > 0) bl1[i] = dzBuyP (stochRvi,DzStartBuyProbability1, DzLookBackBars, Bars, i, 0.0001);
         if (DzStartBuyProbability2  > 0) bl2[i] = dzBuyP (stochRvi,DzStartBuyProbability2, DzLookBackBars, Bars, i, 0.0001);
         if (DzStartSellProbability1 > 0) sl1[i] = dzSellP(stochRvi,DzStartSellProbability1,DzLookBackBars, Bars, i, 0.0001);
         if (DzStartSellProbability2 > 0) sl2[i] = dzSellP(stochRvi,DzStartSellProbability2,DzLookBackBars, Bars, i, 0.0001);
                                          zl1[i] = dzSellP(stochRvi,0.5                    ,DzLookBackBars, Bars, i, 0.0001);
         buffer3[i] = EMPTY_VALUE;
         buffer4[i] = EMPTY_VALUE;
         trend[i]   = trend[i+1];
         slope[i]   = slope[i+1];
         if (stochRvi[i]>stochRviSignal[i]) trend[i] = 1;
         if (stochRvi[i]<stochRviSignal[i]) trend[i] =-1;
         if (stochRvi[i]>stochRvi[i+1])     slope[i] = 1;
         if (stochRvi[i]<stochRvi[i+1])     slope[i] =-1;
         if (slope[i]==-1) PlotPoint(i,buffer3,buffer4,stochRvi);
         manageArrow(i);
   }
   
   //
   //
   //
   //
   //
   
   if (alertsOn)
   {
     if (alertsOnCurrent)
          int whichBar = 0;
     else     whichBar = 1; 

     //
     //
     //
     //
     //
            
     static datetime time1 = 0;
     static string   mess1 = "";
     if (alertsOnSlope && slope[whichBar] != slope[whichBar+1])
     {
        if (slope[whichBar] ==  1) doAlert(time1,mess1,whichBar,"sloping up");
        if (slope[whichBar] == -1) doAlert(time1,mess1,whichBar,"sloping down");
     }
      
     static datetime time2 = 0;
     static string   mess2 = "";
     if (alertsOnSignalCross && trend[whichBar] != trend[whichBar+1])
     {
        if (trend[whichBar] ==  1) doAlert(time2,mess2,whichBar,"crossing signal up");
        if (trend[whichBar] == -1) doAlert(time2,mess2,whichBar,"crossing signal down");
     }
   }
return(0);
}    
  
//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//

double workSto[][5];
#define _hi 0
#define _lo 1
#define _re 2
#define _ma 3
#define _mi 4
double iStoch(double priceR, double priceH, double priceL, int period, int slowing, int i, int instanceNo=0)
{
   if (ArrayRange(workSto,0)!=Bars) ArrayResize(workSto,Bars); i = Bars-i-1; instanceNo *= 5;
   
   //
   //
   //
   //
   //
   
   workSto[i][_hi+instanceNo] = priceH;
   workSto[i][_lo+instanceNo] = priceL;
   workSto[i][_re+instanceNo] = priceR;
   workSto[i][_ma+instanceNo] = priceH;
   workSto[i][_mi+instanceNo] = priceL;
      for (int k=1; k<period && (i-k)>=0; k++)
      {
         workSto[i][_mi+instanceNo] = MathMin(workSto[i][_mi+instanceNo],workSto[i-k][instanceNo+_lo]);
         workSto[i][_ma+instanceNo] = MathMax(workSto[i][_ma+instanceNo],workSto[i-k][instanceNo+_hi]);
      }                   
      double sumlow  = 0.0;
      double sumhigh = 0.0;
      for(k=0; k<slowing; k++)
      {
         sumlow  += workSto[i-k][_re+instanceNo]-workSto[i-k][_mi+instanceNo];
         sumhigh += workSto[i-k][_ma+instanceNo]-workSto[i-k][_mi+instanceNo];
      }

   //
   //
   //
   //
   //
   
   if(sumhigh!=0.0) 
         return(100.0*sumlow/sumhigh);
   else  return(0);    
}

//-------------------------------------------------------------------
//
//-------------------------------------------------------------------
//
//
//
//
//

void CleanPoint(int i,double& first[],double& second[])
{
   if ((second[i]  != EMPTY_VALUE) && (second[i+1] != EMPTY_VALUE))
        second[i+1] = EMPTY_VALUE;
   else
      if ((first[i] != EMPTY_VALUE) && (first[i+1] != EMPTY_VALUE) && (first[i+2] == EMPTY_VALUE))
          first[i+1] = EMPTY_VALUE;
}

//
//
//
//
//

void PlotPoint(int i,double& first[],double& second[],double& from[])
{
   if (first[i+1] == EMPTY_VALUE)
      {
         if (first[i+2] == EMPTY_VALUE) {
                first[i]   = from[i];
                first[i+1] = from[i+1];
                second[i]  = EMPTY_VALUE;
            }
         else {
                second[i]   =  from[i];
                second[i+1] =  from[i+1];
                first[i]    = EMPTY_VALUE;
            }
      }
   else
      {
         first[i]  = from[i];
         second[i] = EMPTY_VALUE;
      }
}

//
//
//
//
//

void doAlert(datetime& previousTime, string& previousAlert, int forBar, string doWhat)
{
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //
       
       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," DDZ Stochastic of Rvi ",doWhat);
          if (alertsMessage) Alert(message);
          if (alertsNotify)  SendNotification(message);
          if (alertsEmail)   SendMail(StringConcatenate(Symbol()," DDZ Stochastic of Rvi "),message);
          if (alertsSound)   PlaySound(soundFile);
   }
}

//------------------------------------------------------------------
//
//------------------------------------------------------------------
//
//
//
//
//

 void manageArrow(int i)
{
   if (ShowArrows)
   {
      ObjectDelete(arrowsIdentifier+":1:"+Time[i]);
      ObjectDelete(arrowsIdentifier+":2:"+Time[i]);
      string lookFor = arrowsIdentifier+":"+Time[i]; ObjectDelete(lookFor);
      if (arrowsOnSlope && slope[i] != slope[i+1])
      {
         if (slope[i] == 1) drawArrow("1",0.5,i,arrowsUpColor,arrowsUpCode,false);
         if (slope[i] ==-1) drawArrow("1",0.5,i,arrowsDnColor,arrowsDnCode, true);
      } 
      if (arrowsOnSignalCross && trend[i] != trend[i+1])
      {
         if (trend[i] == 1) drawArrow("2",1,i,arrowsUpColor,arrowsUpCode,false);
         if (trend[i] ==-1) drawArrow("2",1,i,arrowsDnColor,arrowsDnCode, true);
      }                              
   }         
}             

//
//
//
//
//

void drawArrow(string nameAdd, double gapMul, int i,color theColor,int theCode,bool up)
{
   string name = arrowsIdentifier+":"+nameAdd+":"+Time[i];
   double gap  = iATR(NULL,0,20,i)*gapMul;   
   
      //
      //
      //
      //
      //
      
      ObjectCreate(name,OBJ_ARROW,0,Time[i],0);
         ObjectSet(name,OBJPROP_ARROWCODE,theCode);
         ObjectSet(name,OBJPROP_COLOR,theColor);
         if (up)
               ObjectSet(name,OBJPROP_PRICE1,High[i] + arrowsUpperGap * gap);
         else  ObjectSet(name,OBJPROP_PRICE1,Low[i]  - arrowsLowerGap * gap);
}

//
//
//
//
//

void deleteArrows()
{
   string lookFor       = arrowsIdentifier+":";
   int    lookForLength = StringLen(lookFor);
   for (int i=ObjectsTotal()-1; i>=0; i--)
   {
      string objectName = ObjectName(i);
         if (StringSubstr(objectName,0,lookForLength) == lookFor) ObjectDelete(objectName);
   }
}

//
//
//
//
//

void deleteArrow(datetime time)
{
   string lookFor = arrowsIdentifier+":"+time; ObjectDelete(lookFor);
}



